import { __assign } from "tslib";
import { withThemeableProps } from '../../useThemeable';
import { classNamesFunction } from '@uifabric-vue/utilities';
import Vue from 'vue';
import { FontIcon, Icon } from '../Icon';
var getClassNames = classNamesFunction();
export var CheckBase = Vue.extend({
    name: 'CheckBase',
    props: __assign(__assign({}, withThemeableProps()), { checked: { type: Boolean, default: false }, useFastIcons: { type: Boolean, default: true } }),
    render: function (h, ctx) {
        var _a = ctx.props, checked = _a.checked, className = _a.className, theme = _a.theme, styles = _a.styles, useFastIcons = _a.useFastIcons;
        var classNames = getClassNames(styles, { theme: theme, className: className, checked: checked });
        var IconComponent = useFastIcons ? FontIcon : Icon;
        return h('div', { class: classNames.root }, [
            h(IconComponent, { class: classNames.circle, props: { iconName: 'CircleRating' } }),
            h(IconComponent, { class: classNames.check, props: { iconName: 'StatusCircleCheckmark' } }),
        ]);
    },
});
//# sourceMappingURL=Check.base.js.map