import { __assign, __rest } from "tslib";
import { concatStyleSetsWithProps } from '@uifabric/merge-styles';
import Vue from 'vue';
import { Customizations } from '@uifabric-vue/utilities';
import { getTheme, registerOnThemeChangeCallback } from '@uifabric/styling';
import { ref } from './ref';
var DefaultFields = ['theme', 'styles'];
var theme = ref(getTheme());
registerOnThemeChangeCallback(function (value) {
    theme.value = value;
});
export function styled(Component, baseStyles, getProps, customizable, pure) {
    var _a, _b, _c, _d, _e, _f;
    customizable = customizable || { scope: '', fields: undefined };
    var scope = customizable.scope, _g = customizable.fields, fields = _g === void 0 ? DefaultFields : _g;
    var _styles;
    return Vue.extend({
        name: "Styled".concat(((_c = (_b = (_a = Component === null || Component === void 0 ? void 0 : Component.prototype) === null || _a === void 0 ? void 0 : _a.constructor) === null || _b === void 0 ? void 0 : _b.extendOptions) === null || _c === void 0 ? void 0 : _c.name) || Component.displayName || Component.name),
        functional: true,
        model: (_f = (_e = (_d = Component === null || Component === void 0 ? void 0 : Component.prototype) === null || _d === void 0 ? void 0 : _d.constructor) === null || _e === void 0 ? void 0 : _e.options) === null || _f === void 0 ? void 0 : _f.model,
        render: function (h, context) {
            var settings = Customizations.getSettings(fields, scope);
            var customizedStyles = settings.styles, dir = settings.dir, rest = __rest(settings, ["styles", "dir"]);
            var additionalProps = getProps ? getProps(this) : undefined;
            if (!_styles || customizedStyles !== _styles.__cachedInputs__[1] || !!context.props.styles) {
                _styles = function (styleProps) { return concatStyleSetsWithProps(styleProps, baseStyles, context.props.styles); };
                _styles.__cachedInputs__ = [baseStyles, context.props.styles];
            }
            return h(Component, __assign(__assign({}, context.data), { props: __assign(__assign(__assign(__assign({}, rest), additionalProps), context.props), { className: context.props.className || context.data.class, styles: _styles, theme: theme.value }), scopedSlots: context.scopedSlots }), context.children);
        },
    });
}
//# sourceMappingURL=styled.js.map