import { IProcessedStyleSet } from '@fluentui/style-utilities';
import Vue from 'vue';
import { AnimationDirection, ICalendarMonthStyleProps, ICalendarMonthStyles, ICalendarNavigationIcons } from '..';
import { ICalendarYearRange } from '../CalendarYear/CalendarYear.types';
declare const _default: import("vue/types/vue").ExtendedVue<Vue, {
    isYearPickerVisible: boolean;
}, {
    focusOnNextUpdate(): void;
    onSelectMonth(newMonth: number): void;
    onSelectPrevYear(): void;
    onSelectNextYear(): void;
    onHeaderSelect(): void;
    onYearPickerHeaderSelect(): void;
    onSelectYear(selectedYear: number): void;
}, {
    classNames: IProcessedStyleSet<ICalendarMonthStyles>;
    yearString: string;
    headerAriaLabel: string;
    isPrevYearInBounds: boolean;
    isNextYearInBounds: boolean;
    yearStrings: readonly [(year: number) => any, {
        readonly rangeAriaLabel: (yearRange: ICalendarYearRange) => string;
        readonly prevRangeAriaLabel: (yearRange: ICalendarYearRange) => string;
        readonly nextRangeAriaLabel: (yearRange: ICalendarYearRange) => string;
        readonly headerAriaLabelFormatString: any;
    }];
}, {
    className?: string | undefined;
    styles?: import("@uifabric-vue/utilities").IStyleFunctionOrObject<ICalendarMonthStyleProps, ICalendarMonthStyles> | undefined;
    theme?: import("@fluentui/style-utilities").ITheme | undefined;
    animationDirection?: AnimationDirection | undefined;
    strings: import("../../../../lib/components").ICalendarStrings;
    selectedDate: Date;
    navigatedDate: Date;
    onSelectDate?: void | ((date: Date, selectedDateRangeArray?: Date[] | undefined) => void);
    onNavigateDate: void | ((date: Date, focusOnNavigatedDay: boolean) => void);
    today?: Date | undefined;
    dateTimeFormatter?: import("../../../../lib/components").IDateFormatting | undefined;
    minDate?: Date | undefined;
    maxDate?: Date | undefined;
    allFocusable?: boolean | undefined;
    navigationIcons?: ICalendarNavigationIcons | undefined;
    onHeaderSelect?: void | (() => void);
    highlightCurrentMonth?: boolean | undefined;
    highlightSelectedMonth?: boolean | undefined;
    yearPickerHidden?: boolean | undefined;
}>;
export default _default;
//# sourceMappingURL=CalendarMonth.base.d.ts.map